clear; clc; close all;
%format long g
%[X, map] = imread('me_Singapore.jpg');
load durer
imagedimensions = size(X)

totNumEntries = size(X,1)*size(X,2)

fig1=figure('Color',[1 1 1]);
image(X), colormap(map), axis off, axis equal;
title('{\it Melancholia} by Albrecht Durer (1514)')

%X = double(X(:, :, 2));
X = double(X);

%%
format long g
[U,S,V] = svd(X);
sing = diag(S);
fig2=figure; 
plot(log10(sing)),...
    ylabel('$\log_{10}(\sigma_j)$', 'interpreter', 'latex', 'FontSize',14),...
    xlabel('$j$','interpreter','latex', 'FontSize',14)
title('Singular Values of X')


maxSing = sing(1)
minSing = sing(end)
sumSing = cumsum(sing);
totSing = sumSing(end)
%%
%%% Find number of singluar values to retain "50%, 70%, 90%" of image
truncSing50 = min(find(sumSing > 0.5*sumSing(end)))
truncSing70 = min(find(sumSing > 0.7*sumSing(end)))
truncSing90 = min(find(sumSing > 0.9*sumSing(end)))
%%
k=246; %5, 10, 36, 98, 246
totvar = sum(sing);
percentkept = sum(sing(1:k))/totvar;
entriesStored = k*(size(X,1)+size(X,2)+1);
compressRatio = entriesStored/totNumEntries;

B = U(:,1:k)*S(1:k,1:k)*V(:,1:k)';
R = double(X)-double(B);
relL2Error = norm(R,2)/norm(X,2);

fig3=figure('Color',[1 1 1]);
B = uint8(B);
image(B), colormap(map), axis off, axis equal
title({['k = ', num2str(k)], ...
    ['Singular values used = ', num2str(100*percentkept), '%'], ...
    ['Compression Ratio = ', num2str(100*compressRatio), '%'], ...
    ['Relative L2 Error = ', num2str(100*relL2Error), '%']});

R = uint8(R);
fig4=figure('Color',[1 1 1]);
image(R), colormap(map), axis off, axis equal
title(['Difference Matrix, k= ', num2str(k)]);


